Index: pacemaker/pengine/test10/bug-lf-2619.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-lf-2619.exp
+++ pacemaker/pengine/test10/bug-lf-2619.exp
@@ -83,7 +83,7 @@
     <action_set>
       <rsc_op id="65" operation="monitor" operation_key="prmExPostgreSQLDB1_monitor_5000" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmExPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -96,7 +96,7 @@
     <action_set>
       <rsc_op id="64" operation="start" operation_key="prmExPostgreSQLDB1_start_0" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmExPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -115,7 +115,7 @@
     <action_set>
       <rsc_op id="63" operation="stop" operation_key="prmExPostgreSQLDB1_stop_0" on_node="act1" on_node_uuid="act1">
         <primitive id="prmExPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_on_node="act1" CRM_meta_on_node_uuid="act1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -131,7 +131,7 @@
     <action_set>
       <rsc_op id="68" operation="monitor" operation_key="prmFsPostgreSQLDB1-1_monitor_5000" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmFsPostgreSQLDB1-1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -144,7 +144,7 @@
     <action_set>
       <rsc_op id="67" operation="start" operation_key="prmFsPostgreSQLDB1-1_start_0" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmFsPostgreSQLDB1-1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -163,7 +163,7 @@
     <action_set>
       <rsc_op id="66" operation="stop" operation_key="prmFsPostgreSQLDB1-1_stop_0" on_node="act1" on_node_uuid="act1">
         <primitive id="prmFsPostgreSQLDB1-1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_on_node="act1" CRM_meta_on_node_uuid="act1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -179,7 +179,7 @@
     <action_set>
       <rsc_op id="71" operation="monitor" operation_key="prmFsPostgreSQLDB1-2_monitor_5000" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmFsPostgreSQLDB1-2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -192,7 +192,7 @@
     <action_set>
       <rsc_op id="70" operation="start" operation_key="prmFsPostgreSQLDB1-2_start_0" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmFsPostgreSQLDB1-2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -211,7 +211,7 @@
     <action_set>
       <rsc_op id="69" operation="stop" operation_key="prmFsPostgreSQLDB1-2_stop_0" on_node="act1" on_node_uuid="act1">
         <primitive id="prmFsPostgreSQLDB1-2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_on_node="act1" CRM_meta_on_node_uuid="act1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -227,7 +227,7 @@
     <action_set>
       <rsc_op id="74" operation="monitor" operation_key="prmFsPostgreSQLDB1-3_monitor_5000" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmFsPostgreSQLDB1-3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -240,7 +240,7 @@
     <action_set>
       <rsc_op id="73" operation="start" operation_key="prmFsPostgreSQLDB1-3_start_0" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmFsPostgreSQLDB1-3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -259,7 +259,7 @@
     <action_set>
       <rsc_op id="72" operation="stop" operation_key="prmFsPostgreSQLDB1-3_stop_0" on_node="act1" on_node_uuid="act1">
         <primitive id="prmFsPostgreSQLDB1-3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_on_node="act1" CRM_meta_on_node_uuid="act1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -275,7 +275,7 @@
     <action_set>
       <rsc_op id="77" operation="monitor" operation_key="prmIpPostgreSQLDB1_monitor_5000" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmIpPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -288,7 +288,7 @@
     <action_set>
       <rsc_op id="76" operation="start" operation_key="prmIpPostgreSQLDB1_start_0" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmIpPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -307,7 +307,7 @@
     <action_set>
       <rsc_op id="75" operation="stop" operation_key="prmIpPostgreSQLDB1_stop_0" on_node="act1" on_node_uuid="act1">
         <primitive id="prmIpPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_on_node="act1" CRM_meta_on_node_uuid="act1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -323,7 +323,7 @@
     <action_set>
       <rsc_op id="80" operation="monitor" operation_key="prmApPostgreSQLDB1_monitor_5000" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmApPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -336,7 +336,7 @@
     <action_set>
       <rsc_op id="79" operation="start" operation_key="prmApPostgreSQLDB1_start_0" on_node="sby1" on_node_uuid="sby1">
         <primitive id="prmApPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="sby1" CRM_meta_on_node_uuid="sby1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -355,7 +355,7 @@
     <action_set>
       <rsc_op id="78" operation="stop" operation_key="prmApPostgreSQLDB1_stop_0" on_node="act1" on_node_uuid="act1">
         <primitive id="prmApPostgreSQLDB1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_on_node="act1" CRM_meta_on_node_uuid="act1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -368,7 +368,7 @@
     <action_set>
       <rsc_op id="7" operation="stop" operation_key="prmPingd:0_stop_0" on_node="act1" on_node_uuid="act1">
         <primitive id="prmPingd" long-id="prmPingd:0" class="ocf" provider="pacemaker" type="ping"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="5" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_fail="ignore" CRM_meta_timeout="100000"  dampen="0" host_list="192.168.201.254" multiplier="100" name="default_ping_set"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="5" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_fail="ignore" CRM_meta_on_node="act1" CRM_meta_on_node_uuid="act1" CRM_meta_timeout="100000"  dampen="0" host_list="192.168.201.254" multiplier="100" name="default_ping_set"/>
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/bug-n-385265-2.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-n-385265-2.exp
+++ pacemaker/pengine/test10/bug-n-385265-2.exp
@@ -59,7 +59,7 @@
      <action_set>
       <rsc_op id="5" operation="monitor" operation_key="resource_ip_common_monitor_30000" on_node="ih01" on_node_uuid="9be32c75-0490-4cf9-ae18-c039a94fd327">
         <primitive id="resource_ip_common" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_start_delay="30000" CRM_meta_timeout="25000"  ip="10.116.38.10"/>
+        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_on_node="ih01" CRM_meta_on_node_uuid="9be32c75-0490-4cf9-ae18-c039a94fd327" CRM_meta_start_delay="30000" CRM_meta_timeout="25000"  ip="10.116.38.10"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -72,7 +72,7 @@
      <action_set>
       <rsc_op id="4" operation="start" operation_key="resource_ip_common_start_0" on_node="ih01" on_node_uuid="9be32c75-0490-4cf9-ae18-c039a94fd327">
         <primitive id="resource_ip_common" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_timeout="20000"  ip="10.116.38.10"/>
+        <attributes CRM_meta_on_node="ih01" CRM_meta_on_node_uuid="9be32c75-0490-4cf9-ae18-c039a94fd327" CRM_meta_timeout="20000"  ip="10.116.38.10"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -88,7 +88,7 @@
      <action_set>
       <rsc_op id="2" operation="stop" operation_key="resource_ip_common_stop_0" on_node="ih02" on_node_uuid="57226bfc-310f-409b-8b3d-49d93498e4b5">
         <primitive id="resource_ip_common" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_timeout="20000"  ip="10.116.38.10"/>
+        <attributes CRM_meta_on_node="ih02" CRM_meta_on_node_uuid="57226bfc-310f-409b-8b3d-49d93498e4b5" CRM_meta_timeout="20000"  ip="10.116.38.10"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -104,7 +104,7 @@
      <action_set>
       <rsc_op id="8" operation="monitor" operation_key="resource_idvscommon_monitor_30000" on_node="ih01" on_node_uuid="9be32c75-0490-4cf9-ae18-c039a94fd327">
         <primitive id="resource_idvscommon" class="ocf" provider="dfs" type="idvs"/>
-        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_start_delay="120000" CRM_meta_timeout="25000"  site="common"/>
+        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_on_node="ih01" CRM_meta_on_node_uuid="9be32c75-0490-4cf9-ae18-c039a94fd327" CRM_meta_start_delay="120000" CRM_meta_timeout="25000"  site="common"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -117,7 +117,7 @@
      <action_set>
       <rsc_op id="7" operation="start" operation_key="resource_idvscommon_start_0" on_node="ih01" on_node_uuid="9be32c75-0490-4cf9-ae18-c039a94fd327">
         <primitive id="resource_idvscommon" class="ocf" provider="dfs" type="idvs"/>
-        <attributes CRM_meta_timeout="20000"  site="common"/>
+        <attributes CRM_meta_on_node="ih01" CRM_meta_on_node_uuid="9be32c75-0490-4cf9-ae18-c039a94fd327" CRM_meta_timeout="20000"  site="common"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -136,7 +136,7 @@
      <action_set>
       <rsc_op id="6" operation="stop" operation_key="resource_idvscommon_stop_0" on_node="ih02" on_node_uuid="57226bfc-310f-409b-8b3d-49d93498e4b5">
         <primitive id="resource_idvscommon" class="ocf" provider="dfs" type="idvs"/>
-        <attributes CRM_meta_timeout="20000"  site="common"/>
+        <attributes CRM_meta_on_node="ih02" CRM_meta_on_node_uuid="57226bfc-310f-409b-8b3d-49d93498e4b5" CRM_meta_timeout="20000"  site="common"/>
        </rsc_op>
      </action_set>
      <inputs>
Index: pacemaker/pengine/test10/bug-n-385265.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-n-385265.exp
+++ pacemaker/pengine/test10/bug-n-385265.exp
@@ -26,7 +26,7 @@
      <action_set>
        <rsc_op id="2" operation="stop" operation_key="resource_idvscommon_stop_0" on_node="ih02" on_node_uuid="57226bfc-310f-409b-8b3d-49d93498e4b5">
         <primitive id="resource_idvscommon" class="ocf" provider="dfs" type="idvs"/>
-        <attributes CRM_meta_timeout="20000"  site="common"/>
+        <attributes CRM_meta_on_node="ih02" CRM_meta_on_node_uuid="57226bfc-310f-409b-8b3d-49d93498e4b5" CRM_meta_timeout="20000"  site="common"/>
        </rsc_op>
      </action_set>
      <inputs>
Index: pacemaker/pengine/test10/bug-pm-11.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-pm-11.exp
+++ pacemaker/pengine/test10/bug-pm-11.exp
@@ -30,7 +30,7 @@
      <action_set>
       <rsc_op id="8" operation="start" operation_key="stateful-2:0_start_0" on_node="node-b" on_node_uuid="9b262633-815c-4e5e-8f63-76486cab9ad2">
         <primitive id="stateful-2:0" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-b" CRM_meta_on_node_uuid="9b262633-815c-4e5e-8f63-76486cab9ad2" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -43,7 +43,7 @@
      <action_set>
       <rsc_op id="4" operation="monitor" operation_key="stateful-2:0_monitor_0" on_node="node-b" on_node_uuid="9b262633-815c-4e5e-8f63-76486cab9ad2">
         <primitive id="stateful-2:0" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-b" CRM_meta_on_node_uuid="9b262633-815c-4e5e-8f63-76486cab9ad2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -52,7 +52,7 @@
      <action_set>
       <rsc_op id="2" operation="monitor" operation_key="stateful-2:0_monitor_0" on_node="node-a" on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d">
         <primitive id="stateful-2:0" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-a" CRM_meta_on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -112,7 +112,7 @@
      <action_set>
       <rsc_op id="22" operation="promote" operation_key="stateful-2:1_promote_0" on_node="node-a" on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-a" CRM_meta_on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -128,7 +128,7 @@
      <action_set>
       <rsc_op id="21" operation="start" operation_key="stateful-2:1_start_0" on_node="node-a" on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-a" CRM_meta_on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -141,7 +141,7 @@
      <action_set>
       <rsc_op id="5" operation="monitor" operation_key="stateful-2:1_monitor_0" on_node="node-b" on_node_uuid="9b262633-815c-4e5e-8f63-76486cab9ad2">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-b" CRM_meta_on_node_uuid="9b262633-815c-4e5e-8f63-76486cab9ad2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -150,7 +150,7 @@
      <action_set>
       <rsc_op id="3" operation="monitor" operation_key="stateful-2:1_monitor_0" on_node="node-a" on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-a" CRM_meta_on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
      </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/bug-pm-12.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-pm-12.exp
+++ pacemaker/pengine/test10/bug-pm-12.exp
@@ -60,7 +60,7 @@
      <action_set>
       <rsc_op id="6" operation="stop" operation_key="stateful-2:0_stop_0" on_node="node-b" on_node_uuid="9b262633-815c-4e5e-8f63-76486cab9ad2">
         <primitive id="stateful-2:0" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000"  test1="1" test2="2"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-b" CRM_meta_on_node_uuid="9b262633-815c-4e5e-8f63-76486cab9ad2" CRM_meta_timeout="20000"  test1="1" test2="2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -73,7 +73,7 @@
      <action_set>
       <rsc_op id="2" operation="start" operation_key="stateful-2:0_start_0" on_node="node-b" on_node_uuid="9b262633-815c-4e5e-8f63-76486cab9ad2">
         <primitive id="stateful-2:0" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000"  test1="1" test2="2"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-b" CRM_meta_on_node_uuid="9b262633-815c-4e5e-8f63-76486cab9ad2" CRM_meta_timeout="20000"  test1="1" test2="2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -197,7 +197,7 @@
      <action_set>
       <rsc_op id="21" operation="promote" operation_key="stateful-2:1_promote_0" on_node="node-a" on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000"  test1="1" test2="2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-a" CRM_meta_on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d" CRM_meta_timeout="20000"  test1="1" test2="2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -213,7 +213,7 @@
      <action_set>
       <rsc_op id="20" operation="stop" operation_key="stateful-2:1_stop_0" on_node="node-a" on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000"  test1="1" test2="2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-a" CRM_meta_on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d" CRM_meta_timeout="20000"  test1="1" test2="2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -229,7 +229,7 @@
      <action_set>
       <rsc_op id="19" operation="demote" operation_key="stateful-2:1_demote_0" on_node="node-a" on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000"  test1="1" test2="2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-a" CRM_meta_on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d" CRM_meta_timeout="20000"  test1="1" test2="2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -242,7 +242,7 @@
      <action_set>
       <rsc_op id="3" operation="start" operation_key="stateful-2:1_start_0" on_node="node-a" on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d">
         <primitive id="stateful-2:1" class="ocf" provider="heartbeat" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000"  test1="1" test2="2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-a" CRM_meta_on_node_uuid="babfee4b-9c89-4df2-8ccb-3de2a3587d8d" CRM_meta_timeout="20000"  test1="1" test2="2"/>
        </rsc_op>
      </action_set>
      <inputs>
